Bug 1957315

Summary: kuryr-controller doesn't indicate being out of quota
Product: OpenShift Container Platform Reporter: Michał Dulko <mdulko>
Component: NetworkingAssignee: Michał Dulko <mdulko>
Networking sub component: kuryr QA Contact: Itzik Brown <itbrown>
Status: CLOSED ERRATA Docs Contact:
Severity: medium    
Priority: medium    
Version: 4.8   
Target Milestone: ---   
Target Release: 4.8.0   
Hardware: All   
OS: All   
Whiteboard:
Fixed In Version: Doc Type: No Doc Update
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-07-27 23:06:36 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:

Description Michał Dulko 2021-05-05 15:15:08 UTC
Description of problem:
We have a system that will disable kuryr-controller readiness when there's no quota for creation of new OpenStack resource. This doesn't work now.

Version-Release number of selected component (if applicable):


How reproducible:
Always.

Steps to Reproduce:
1. Run installation with Kuryr.
2. Count all the subnets in the shiftstack project.
3. Reduce subnets quotas for shiftstack project ot the number from 2.

Actual results:
kuryr-controller will just produce a warning in the logs.

Expected results:
kuryr-controller pod readiness should become 0/1.

Additional info:

Comment 2 Itzik Brown 2021-05-12 09:06:43 UTC
Verified using:
OCP 4.8.0-0.nightly-2021-05-10-225140
OSP RHOS-16.1-RHEL-8-20210323.n.0

Checking the number of subnets(As the tenant):
$ source shiftstackrc && openstack subnet list -c ID -f value |wc -l
69

Set the quota (As admin) to one less the number of subnets currently in use 
$ source overcloudrc && openstack quota set --subnets 68 shiftstack

After 5 minutes checking that the Kuryr controller is not ready:
$ oc get pods -n openshift-kuryr
NAME                               READY   STATUS    RESTARTS   AGE
kuryr-cni-2m96d                    1/1     Running   0          77m
kuryr-cni-bfwxj                    1/1     Running   0          75m
kuryr-cni-rn9ll                    1/1     Running   0          75m
kuryr-cni-vmv8p                    1/1     Running   0          76m
kuryr-cni-zr6jb                    1/1     Running   0          74m
kuryr-controller-648cd759b-l5bcq   0/1     Running   0          73m

Checking the Kuryr controller logs
$ oc logs kuryr-controller-648cd759b-l5bcq -n openshift-kuryr
2021-05-12 08:59:19.034 1 ERROR kuryr_kubernetes.utils [-] Neutron quota exceeded for subnets. Used 69 out of 68 limit.
2021-05-12 08:59:19.035 1 ERROR kuryr_kubernetes.controller.handlers.namespace [-] Marking NamespaceHandler as not ready.

Set the quota back
$ source overcloudrc && openstack quota set --subnets 100 shiftstack

Checking that Kuryr controller is ready
$ oc get pods -n openshift-kuryr
NAME                               READY   STATUS    RESTARTS   AGE
kuryr-cni-2m96d                    1/1     Running   0          82m
kuryr-cni-bfwxj                    1/1     Running   0          80m
kuryr-cni-rn9ll                    1/1     Running   0          80m
kuryr-cni-vmv8p                    1/1     Running   0          81m
kuryr-cni-zr6jb                    1/1     Running   0          79m
kuryr-controller-648cd759b-l5bcq   1/1     Running   0          78m

Comment 5 errata-xmlrpc 2021-07-27 23:06:36 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory (Moderate: OpenShift Container Platform 4.8.2 bug fix and security update), and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2021:2438